sahara_dashboard/content/data_processing/clusters/urls.py
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
# implied.
# See the License for the specific language governing permissions and
# limitations under the License.


from django.urls import re_path

import sahara_dashboard.content.data_processing.clusters.views as views
import sahara_dashboard.content.data_processing.clusters.image_registry. \
    views as image_views
import sahara_dashboard.content.data_processing.clusters.nodegroup_templates. \
    views as ngt_views
import sahara_dashboard.content.data_processing.clusters.cluster_templates. \
    views as ct_views
import sahara_dashboard.content.data_processing.clusters.clusters. \
    views as cluster_views
import sahara_dashboard.content.data_processing.clusters.wizard. \
    views as cluster_guide_views


urlpatterns = [re_path(r'^$', views.IndexView.as_view(), name='index'),
               re_path(r'^\?tab=cluster_tabs__image_registry_tab$',
                       views.IndexView.as_view(), name='image-registry-tab'),
               re_path(r'^\?tab=cluster_tabs__node_group_templates_tab$',
                       views.IndexView.as_view(),
                       name='nodegroup-templates-tab'),
               re_path(r'^\?tab=cluster_tabs__clusters_templates_tab$',
                       views.IndexView.as_view(),
                       name='cluster-templates-tab'),
               re_path(r'^\?tab=cluster_tabs__clusters_tab$',
                       views.IndexView.as_view(), name='clusters-tab'),
               re_path(r'^create-cluster-template$',
                       ct_views.CreateClusterTemplateView.as_view(),
                       name='create-cluster-template'),
               re_path(r'^create-nodegroup-template$',
                       ngt_views.CreateNodegroupTemplateView.as_view(),
                       name='create-nodegroup-template'),
               re_path(r'^configure-cluster-template$',
                       ct_views.ConfigureClusterTemplateView.as_view(),
                       name='configure-cluster-template'),
               re_path(r'^import-cluster-template-file$',
                       ct_views.ImportClusterTemplateFileView.as_view(),
                       name='import-cluster-template-file'),
               re_path(r'^import-cluster-template-name$',
                       ct_views.ImportClusterTemplateNameView.as_view(),
                       name='import-cluster-template-name'),
               re_path(r'^import-cluster-template-nodegroups$',
                       ct_views.ImportClusterTemplateNodegroupsView.as_view(),
                       name='import-cluster-template-nodegroups'),
               re_path(r'^configure-nodegroup-template$',
                       ngt_views.ConfigureNodegroupTemplateView.as_view(),
                       name='configure-nodegroup-template'),
               re_path(r'^import-nodegroup-template-file$',
                       ngt_views.ImportNodegroupTemplateFileView.as_view(),
                       name='import-nodegroup-template-file'),
               re_path(r'^import-nodegroup-template-details$',
                       ngt_views.ImportNodegroupTemplateDetailsView.as_view(),
                       name='import-nodegroup-template-details'),
               re_path(r'^cluster-template/(?P<template_id>[^/]+)$',
                       ct_views.ClusterTemplateDetailsView.as_view(),
                       name='ct-details'),
               re_path(r'^node-group-template/(?P<template_id>[^/]+)$',
                       ngt_views.NodegroupTemplateDetailsView.as_view(),
                       name='details'),
               re_path(r'^cluster-template/(?P<template_id>[^/]+)/copy$',
                       ct_views.CopyClusterTemplateView.as_view(),
                       name='ct-copy'),
               re_path(r'^cluster-template/(?P<template_id>[^/]+)/edit$',
                       ct_views.EditClusterTemplateView.as_view(),
                       name='ct-edit'),
               re_path(r'^node-group-template/(?P<template_id>[^/]+)/copy$',
                       ngt_views.CopyNodegroupTemplateView.as_view(),
                       name='copy'),
               re_path(r'^node-group-template/(?P<template_id>[^/]+)/edit$',
                       ngt_views.EditNodegroupTemplateView.as_view(),
                       name='edit'),
               re_path(r'^create-cluster$',
                       cluster_views.CreateClusterView.as_view(),
                       name='create-cluster'),
               re_path(r'^configure-cluster$',
                       cluster_views.ConfigureClusterView.as_view(),
                       name='configure-cluster'),
               re_path(r'^cluster/(?P<cluster_id>[^/]+)$',
                       cluster_views.ClusterDetailsView.as_view(),
                       name='cluster-details'),
               re_path(r'^cluster/(?P<cluster_id>[^/]+)/events$',
                       cluster_views.ClusterEventsView.as_view(),
                       name='events'),
               re_path(r'^cluster/(?P<cluster_id>[^/]+)/scale$',
                       cluster_views.ScaleClusterView.as_view(),
                       name='scale'),
               re_path(r'^cluster/(?P<cluster_id>[^/]+)/verifications$',
                       cluster_views.ClusterHealthChecksView.as_view(),
                       name='verifications'),
               re_path(r'^cluster/(?P<cluster_id>[^/]+)/update_shares$',
                       cluster_views.UpdateClusterSharesView.as_view(),
                       name='update-shares'),
               re_path(r'^edit_tags/(?P<image_id>[^/]+)/$',
                       image_views.EditTagsView.as_view(), name='edit_tags'),
               re_path(r'^register/$',
                       image_views.RegisterImageView.as_view(),
                       name='register'),
               re_path(r'^cluster_guide$',
                       cluster_guide_views.ClusterGuideView.as_view(),
                       name='cluster_guide'),
               re_path(r'^cluster_guide/(?P<reset_cluster_guide>[^/]+)/$',
                       cluster_guide_views.ResetClusterGuideView.as_view(),
                       name='reset_cluster_guide'),
               re_path(r'^image_register/$',
                       cluster_guide_views.ImageRegisterView.as_view(),
                       name='image_register'),
               re_path(r'^plugin_select$',
                       cluster_guide_views.PluginSelectView.as_view(),
                       name='plugin_select'),
               re_path(r'^ngt_select$',
                       cluster_guide_views.NodeGroupSelectView.as_view(),
                       name='ngt_select'), ]

sahara_dashboard/content/data_processing/jobs/urls.py
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
# implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from django.urls import re_path

import sahara_dashboard.content.data_processing. \
    jobs.views as views
import sahara_dashboard.content.data_processing. \
    jobs.job_binaries.views as job_binary_views
import sahara_dashboard.content.data_processing. \
    jobs.data_sources.views as data_source_views
import sahara_dashboard.content.data_processing. \
    jobs.job_templates.views as job_templates_views
import sahara_dashboard.content.data_processing. \
    jobs.wizard.views as job_wizard_views
import sahara_dashboard.content.data_processing. \
    jobs.jobs.views as jobs_views


urlpatterns = [re_path(r'^$', views.IndexView.as_view(), name='index'),
               re_path(r'^$', views.IndexView.as_view(), name='jobs'),
               re_path(r'^\?tab=job_tabs__jobs_tab$',
                       views.IndexView.as_view(),
                       name='jobs-tab'),
               re_path(r'^create-job$',
                       job_templates_views.CreateJobView.as_view(),
                       name='create-job'),
               re_path(r'^launch-job$',
                       job_templates_views.LaunchJobView.as_view(),
                       name='launch-job'),
               re_path(r'^launch-job-new-cluster$', job_templates_views.
                       LaunchJobNewClusterView.as_view(),
                       name='launch-job-new-cluster'),
               re_path(r'^choose-plugin$',
                       job_templates_views.ChoosePluginView.as_view(),
                       name='choose-plugin'),
               re_path(r'^job-template/(?P<job_id>[^/]+)$',
                       job_templates_views.
                       JobTemplateDetailsView.as_view(), name='jt-details'),
               re_path(r'^job-execution/(?P<job_execution_id>[^/]+)$',
                       jobs_views.JobDetailsView.as_view(), name='details'),
               re_path(r'^create-job-binary$',
                       job_binary_views.CreateJobBinaryView.as_view(),
                       name='create-job-binary'),
               re_path(r'^job-binary/(?P<job_binary_id>[^/]+)$',
                       job_binary_views.JobBinaryDetailsView.as_view(),
                       name='jb-details'),
               re_path(r'^job-binary/(?P<job_binary_id>[^/]+)/edit$',
                       job_binary_views.EditJobBinaryView.as_view(),
                       name='edit-job-binary'),
               re_path(r'^job-binary/(?P<job_binary_id>[^/]+)/download/$',
                       job_binary_views.DownloadJobBinaryView.as_view(),
                       name='download'),
               re_path(r'^create-data-source$',
                       data_source_views.CreateDataSourceView.as_view(),
                       name='create-data-source'),
               re_path(r'^data-source/(?P<data_source_id>[^/]+)/edit$',
                       data_source_views.EditDataSourceView.as_view(),
                       name='edit-data-source'),
               re_path(r'^data-source/(?P<data_source_id>[^/]+)$',
                       data_source_views.DataSourceDetailsView.as_view(),
                       name='ds-details'),
               re_path(r'^jobex_guide$',
                       job_wizard_views.JobExecutionGuideView.as_view(),
                       name='jobex_guide'),
               re_path(r'^jobex_guide/(?P<reset_jobex_guide>[^/]+)/$',
                       job_wizard_views.ResetJobExGuideView.as_view(),
                       name='reset_jobex_guide'),
               re_path(r'^job_type_select$',
                       job_wizard_views.JobTypeSelectView.as_view(),
                       name='job_type_select'),
               ]

sahara_dashboard/content/data_processing/clusters/image_registry/forms.py
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
# implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import json

from django.utils.translation import gettext_lazy as _

from horizon import exceptions
from horizon import forms
from horizon import messages
from openstack_dashboard.api import glance

from sahara_dashboard.api import sahara as saharaclient


class ImageForm(forms.SelfHandlingForm):
    image_id = forms.CharField(widget=forms.HiddenInput())
    tags_list = forms.CharField(widget=forms.HiddenInput())
    user_name = forms.CharField(max_length=80, label=_("User Name"))
    description = forms.CharField(max_length=80,
                                  label=_("Description"),
                                  required=False,
                                  widget=forms.Textarea(attrs={'rows': 4}))

    def handle(self, request, data):
        try:
            image_id = data['image_id']
            user_name = data['user_name']
            desc = data['description']
            saharaclient.image_update(request, image_id, user_name, desc)

            image_tags = json.loads(data["tags_list"])
            saharaclient.image_tags_update(request, image_id, image_tags)
            updated_image = saharaclient.image_get(request, image_id)
            messages.success(request,
                             _("Successfully updated image."))
            return updated_image
        except Exception:
            exceptions.handle(request,
                              _("Failed to update image."))
            return False


class EditTagsForm(ImageForm):
    image_id = forms.CharField(widget=forms.HiddenInput())


class RegisterImageForm(ImageForm):
    image_id = forms.ChoiceField(label=_("Image"))

    def __init__(self, request, *args, **kwargs):
        super(RegisterImageForm, self).__init__(request, *args, **kwargs)
        self._populate_image_id_choices()

    def _populate_image_id_choices(self):
        images = self._get_available_images(self.request)
        choices = [(image.id, image.name)
                   for image in images
                   if image.to_dict()['properties'].get(
                       "image_type") != "snapshot"]
        if choices:
            choices.insert(0, ("", _("Select Image")))
        else:
            choices.insert(0, ("", _("No images available.")))
        self.fields['image_id'].choices = choices

    def _get_images(self, request, filter):
        try:
            images, _more, _prev = (
                glance.image_list_detailed(request, filters=filter))
        except Exception:
            images = []
            exceptions.handle(request,
                              _("Unable to retrieve images with filter %s.") %
                              filter)
        return images

    def _get_public_images(self, request):
        filter = {"is_public": True,
                  "status": "active"}
        return self._get_images(request, filter)

    def _get_tenant_images(self, request):
        filter = {"owner": request.user.tenant_id,
                  "status": "active"}
        return self._get_images(request, filter)

    def _get_available_images(self, request):

        images = self._get_tenant_images(request)
        if request.user.is_superuser:
            images += self._get_public_images(request)

        final_images = []

        try:
            image_ids = set(img.id for img in saharaclient.image_list(request))
        except Exception:
            image_ids = set()
            exceptions.handle(request,
                              _("Unable to fetch available images."))

        for image in images:
            if (image not in final_images and
                    image.id not in image_ids and
                    image.container_format not in ('aki', 'ari')):
                final_images.append(image)
        return final_images

sahara_dashboard/content/data_processing/clusters/views.py
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
# implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from django.utils.translation import gettext_lazy as _

from horizon import tabs

from sahara_dashboard.content.data_processing.clusters.cluster_templates \
    import tabs as cluster_templates_tabs
from sahara_dashboard.content.data_processing.clusters.clusters \
    import tabs as clusters_tabs
from sahara_dashboard.content.data_processing.clusters.image_registry \
    import tabs as image_registry_tabs
from sahara_dashboard.content.data_processing.clusters.nodegroup_templates \
    import tabs as node_group_templates_tabs
from sahara_dashboard.content.data_processing.tabs \
    import PaginationFriendlyTabGroup


class ClusterTabs(PaginationFriendlyTabGroup):
    slug = "cluster_tabs"
    tabs = (clusters_tabs.ClustersTab,
            cluster_templates_tabs.ClusterTemplatesTab,
            node_group_templates_tabs.NodeGroupTemplatesTab,
            image_registry_tabs.ImageRegistryTab,)
    sticky = True


class IndexView(tabs.TabbedTableView):
    tab_group_class = ClusterTabs
    template_name = "clusters/index.html"
    page_title = _("Clusters")

sahara_dashboard/content/data_processing/clusters/templates/clusters/_configure_general_help.html
{% load i18n horizon %}
<div class="well">
<p>
    {% blocktrans %}This Cluster will be started with:{% endblocktrans %}
    <br >
    <b>{% blocktrans %}Plugin{% endblocktrans %}</b>: {{ plugin_name }}
    <br />
    <b>{% blocktrans %}Version{% endblocktrans %}</b>: {{ hadoop_version }}
    <br />
</p>
<p>
    {% blocktrans %}Cluster can be launched using existing Cluster Templates.{% endblocktrans %}
</p>
<p>
    {% blocktrans %}The Cluster object should specify OpenStack Image to boot instances for Cluster.{% endblocktrans %}
</p>
<p>
    {% blocktrans %}User has to choose a keypair to have access to clusters instances.{% endblocktrans %}
</p>
</div>

sahara_dashboard/content/data_processing/clusters/templates/clusters/_create_cluster.html
{% extends "horizon/common/_modal_form.html" %}


{% load i18n %}

{% block form_id %}create_cluster_form{% endblock %}
{% block form_action %}{% url 'horizon:project:data_processing.clusters:create' %}{% endblock %}

{% block modal-header %}{% trans "Launch Cluster" %}{% endblock %}

{% block modal-body %}
    <div class="left">
        <fieldset>
            {% include "horizon/common/_form_fields.html" %}
        </fieldset>
    </div>
{% endblock %}

{% block modal-footer %}
    <input class="btn btn-primary pull-right" id="create_cluster_btn" type="submit" value="{% trans " Done" %}"/>
    <a href="{% url 'horizon:project:data_processing.clusters:index' %}"
       class="btn btn-default cancel">{% trans "Cancel" %}</a>
{% endblock %}

sahara_dashboard/content/data_processing/clusters/templates/clusters/_create_general_help.html
{% load i18n %}
<p class="well">
    {% trans "Select a plugin and version for a new Cluster." %}
</p>

sahara_dashboard/content/data_processing/clusters/templates/clusters/_details.html
{% load i18n sizeformat %}

<div class="detail">
  <dl class="dl-horizontal">
    <dt>{% trans "Name" %}</dt>
    <dd>{{ cluster.name }}</dd>
    <dt>{% trans "Project ID" %}</dt>
    {% if cluster.tenant_id %}
    <dd>{{ cluster.tenant_id }}</dd>
    {% else %}
    <dd>{{ cluster.project_id }}</dd>
    {% endif %}
    <dt>{% trans "ID" %}</dt>
    <dd>{{ cluster.id }}</dd>
    <dt>{% trans "Description" %}</dt>
    <dd>{{ cluster.description|default:_("None") }}</dd>
    <dt>{% trans "Status" %}</dt>
    <dd>{{ cluster.status }}</dd>
    <dt>{% trans "Status description" %}</dt>
    {% if cluster.status_description %}
      <dd>{{ cluster.status_description }}</dd>
    {% else %}
      <dd>{% trans "No description" %}</dd>
    {% endif %}
  </dl>

  {% if cluster.error_description %}
    <h4>{% trans "Error Details" %}</h4>
    <p class="well">
        {{ cluster.error_description }}
    </p>
  {% endif %}

  <dl class="dl-horizontal">
    <dt>{% trans "Plugin" %}</dt>
    <dd><a href="{% url 'horizon:project:data_processing.data_plugins:plugin-details' cluster.plugin_name %}">{{ cluster.plugin_name }}</a></dd>
    <dt>{% trans "Version" %}</dt>
    <dd>{{ cluster.hadoop_version }}</dd>
  </dl>
  <dl class="dl-horizontal">
    <dt>{% trans "Template" %}</dt>
    {% if cluster_template %}
      <dd><a href="{% url 'horizon:project:data_processing.clusters:ct-details' cluster_template.id %}">{{ cluster_template.name }} </a></dd>
    {% else %}
      <dd>{% trans "Template not specified" %}</dd>
    {% endif %}
    {% if base_image.id %}
      <dt>{% trans "Base Image" %}</dt>
      <dd><a href="{% url 'horizon:project:images:images:detail' base_image.id %}">{{ base_image.name }}</a></dd>
    {% endif %}
    {% if network %}
      <dt>{% trans "Neutron Management Network" %}</dt>
      <dd>{{ network }}</dd>
    {% endif %}
    <dt>{% trans "Keypair" %}</dt>
    <dd>{{ cluster.user_keypair_id }}</dd>
    <dt>{% trans "Use auto-configuration" %}</dt>
    <dd>{{ cluster.use_autoconfig }}</dd>
    <dt>{% trans "Public" %}</dt>
    <dd>{{ cluster.is_public|yesno }}</dd>
    <dt>{% trans "Protected" %}</dt>
    <dd>{{ cluster.is_protected|yesno }}</dd>
  </dl>
  <dl class="dl-horizontal">
    <dt>{% trans "Anti-affinity enabled for" %}</dt>
      {% if cluster.anti_affinity %}
        <dd>
          <ul class="list-bullet">
          {% for process in cluster.anti_affinity %}
            <li>{{ process }}</li>
          {% endfor %}
          </ul>
        </dd>
      {% else %}
        <h6>{% trans "no processes" %}</h6>
      {% endif %}
    </dl>
  <dl class="dl-horizontal">
    {% for info_key, info_val in cluster.info.items %}
      <dt>{{ info_key }}</dt>
      {% for key, val in info_val.items %}
        <dd>
          {% autoescape off %}{% blocktrans %}{{ key }}: {{ val }}{% endblocktrans %}{% endautoescape %}
        </dd>
      {% endfor %}
    {% endfor %}
  </dl>
</div>

sahara_dashboard/content/data_processing/clusters/templates/clusters/_event_log.html
{% load i18n %}

<h4>{% trans "Cluster provision steps" %}</h4>
<table id="steps_table" class="table table-bordered datatable">
    <thead>
        <tr>
            <th>{% trans "Step Description" %}</th>
            <th>{% trans "Started at" %}</th>
            <th>{% trans "Duration" %}</th>
            <th>{% trans "Progress" %}</th>
            <th>{% trans "Status" %}</th>
        </tr>
    </thead>
    <tbody id="steps_body">
    </tbody>
</table>

<div id="events_modal" class="modal fade">
    <div class="modal-dialog" style="width: 85%">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                <h4 id="events_modal_header"></h4>
                <span id="modal_status_marker"></span>
            </div>
            <div class="modal-body">
                <table id="events_table" class="table table-bordered datatable">
                    <thead>
                        <tr>
                            <th>{% trans "Node Group" %}</th>
                            <th>{% trans "Instance" %}</th>
                            <th>{% trans "Event time" %}</th>
                            <th>{% trans "Info" %}</th>
                            <th>{% trans "Status" %}</th>
                        </tr>
                    </thead>
                    <tbody id="events_body">
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">

    $(function () {
        // Initialize everything.
        horizon.event_log.cluster_id = "{{ cluster_id }}";
        horizon.event_log.data_update_url = "{{ data_update_url }}";
        horizon.event_log.fetch_update_events();
    });

    $(".show_events_btn").live("click", function () {
        // Bind "show events" buttons to modals.
        horizon.event_log.modal_step_id = $(this).data("step-id");
        horizon.event_log.clear_events();
        horizon.event_log.clear_modal_status();
        horizon.event_log.update_events_rows(horizon.event_log.cached_data);
    });

</script>

sahara_dashboard/content/data_processing/clusters/templates/clusters/index.html
{% extends 'base.html' %}
{% load i18n %}
{% block title %}{% trans "Clusters" %}{% endblock %}

{% block main %}
<div class="row">
  <div class="col-sm-12">
    {{ tab_group.render }}
  </div>
</div>

<script type="text/javascript">
  addHorizonLoadEvent(function () {
      horizon.modals.addModalInitFunction(function (modal) {
        if ($("#id_tags_list").val()) {
            var tags = JSON.parse($("#id_tags_list").val());
            $.each(tags, function (i, tag) {
                var tagspan = '<span class="label label-info" id="image-tag">' +
                        tag +
                        '<i class="fa fa-close" onclick="remove_tag(this);"></i></span>';
                $("#image_tags_list").append(tagspan);
            });
        }
     });
  });
</script>

<script type="text/javascript">
    addHorizonLoadEvent(function () {
        horizon.modals.addModalInitFunction(function (modal) {
            // ensure that we only do this for the cluster template form
            if (($(modal).find("#create_cluster_template__selectpluginaction")).length > 0) {

                var add_ng_btn_label = '{% trans "Add Node Group" %}';
                $(".hidden_nodegroups_field").after("<input type='button' id='add_nodegroup' value='" + add_ng_btn_label + "'/><br/>");
                $("#add_nodegroup").click(function() {
                    $(".hidden_nodegroups_field").val("create_nodegroup");
                    $(".hidden_configure_field").val("create_nodegroup");
                    var form = $(".hidden_nodegroups_field").closest("form");
                    form.submit();
                });


                $(".hidden_nodegroups_field").val("");
                $(".hidden_configure_field").val("");

                if ($(modal).find(".hidden_create_field").length > 0) {
                    var form = $(".hidden_create_field").closest("form");
                    var successful = false;
                    form.submit(function (e) {
                            var oldHref = $(".configure-clustertemplate-btn")[0].href;
                            var plugin = $("#id_plugin_name option:selected").val();
                            var version = $("#id_" + plugin + "_version option:selected").val();
                            form.find(".close").click();
                            $(".configure-clustertemplate-btn")[0].href = oldHref +
                                    "?plugin_name=" + encodeURIComponent(plugin) +
                                    "&hadoop_version=" + encodeURIComponent(version);
                            $(".configure-clustertemplate-btn").click();
                            $(".configure-clustertemplate-btn")[0].href = oldHref;
                            return false;
                    });
                }
            }
        });

    });
</script>

 <script type="text/javascript">
        addHorizonLoadEvent(function () {
            function get_service_tab(service) {
                return $("a").filter(function (idx, e) {
                    return $(e).attr("data-target") && $(e).attr("data-target").indexOf('_'+service.toLowerCase()+'-') != -1
                }).closest("li");
            }

            // replace form submit with ajax POST and trigger next workflow
            horizon.modals.addModalInitFunction(function (modal) {
                // ensure that we only do this for the nodegroup template form
                if (($(modal).find("#create_nodegroup_template__selectpluginaction")).length > 0) {

                    if ($(modal).find(".hidden_create_field").length > 0) {
                        var form = $(".hidden_create_field").closest("form");
                        var successful = false;
                        form.submit(function (e) {
                            var oldHref = $(".configure-nodegrouptemplate-btn")[0].href;
                            var plugin = $("#id_plugin_name option:selected").val();
                            var version = $("#id_" + plugin + "_version option:selected").val();
                            form.find(".close").click();
                            $(".configure-nodegrouptemplate-btn")[0].href = oldHref +
                                    "?plugin_name=" + encodeURIComponent(plugin) +
                                    "&hadoop_version=" + encodeURIComponent(version);
                            $(".configure-nodegrouptemplate-btn").click();
                            $(".configure-nodegrouptemplate-btn")[0].href = oldHref;
                            return false;
                        });
                    }
                }

                //handle node processes change
                $("input").filter(function (idx, e) {
                    return $(e).attr("name") && $(e).attr("name").indexOf("processes") != -1
                })
                        .change(function () {
                            var process_service = $(this).val();
                            var service = $(this).val().split(":")[0];
                            var enabled = false;
                            $(this).closest("ul").find("input").each(function (idx, el) {
                                if ($(el).val().split(":")[0] != service) {
                                    return;
                                }
                                enabled |= $(el).is(':checked');
                            });
                            if (enabled) {
                                get_service_tab(service).show();
                            } else {
                                get_service_tab(service).hide();
                            }
                        }).change();
                //general tab should be active
                get_service_tab("generalconfigaction").find("a").click();
            });
        });
    </script>

<script type="text/javascript">
    addHorizonLoadEvent(function () {

        horizon.modals.addModalInitFunction(function (modal) {
            // ensure that we only do this for the create cluster form
            if (($(modal).find("#create_cluster__selectpluginaction")).length > 0) {

                $(".hidden_nodegroups_field").val("");
                $(".hidden_configure_field").val("");

                lower_limit = 0;
                $(".count-field").change();

                if ($(modal).find(".hidden_create_field").length > 0) {
                    var form = $(".hidden_create_field").closest("form");
                    var successful = false;
                    form.submit(function (e) {
                        var oldHref = $(".configure-cluster-btn")[0].href;
                        var plugin = $("#id_plugin_name option:selected").val();
                        var version = $("#id_" + plugin + "_version option:selected").val();
                        form.find(".close").click();
                        $(".configure-cluster-btn")[0].href = oldHref +
                                "?plugin_name=" + encodeURIComponent(plugin) +
                                "&hadoop_version=" + encodeURIComponent(version);
                        $(".configure-cluster-btn").click();
                        $(".configure-cluster-btn")[0].href = oldHref;
                        return false;
                    });
                }
            }
        });

    });
</script>

{% endblock %}